// -*- C++ -*-
/*!
 * @file  testA.cpp
 * @brief testA
 * @date $Date$
 *
 * $Id$
 */

#include "testA.h"

// Module specification
// <rtc-template block="module_spec">
static const char* testa_spec[] =
  {
    "implementation_id", "testA",
    "type_name",         "testA",
    "description",       "testA",
    "version",           "1.0.0",
    "vendor",            "VenderName",
    "category",          "Category",
    "activity_type",     "PERIODIC",
    "kind",              "DataFlowComponent",
    "max_instance",      "1",
    "language",          "C++",
    "lang_type",         "compile",
    "exec_cxt.periodic.rate", "1.0",
    ""
  };
// </rtc-template>

/*!
 * @brief constructor
 * @param manager Maneger Object
 */
testA::testA(RTC::Manager* manager)
    // <rtc-template block="initializer">
  : RTC::DataFlowComponentBase(manager),
    m_SendOut("Send", m_Send)

    // </rtc-template>
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  
  // Set OutPort buffer
  registerOutPort("Send", m_SendOut);
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  
  // </rtc-template>

}

/*!
 * @brief destructor
 */
testA::~testA()
{
}



RTC::ReturnCode_t testA::onInitialize()
{
	std::cout << "[onInitialize()]" << std::endl;

  return RTC::RTC_OK;
}


RTC::ReturnCode_t testA::onFinalize()
{
	std::cout << "[onFinalize()]" << std::endl;

  return RTC::RTC_OK;
}


RTC::ReturnCode_t testA::onStartup(RTC::UniqueId ec_id)
{
	std::cout << "[onStartup()]" << std::endl;

  return RTC::RTC_OK;
}


RTC::ReturnCode_t testA::onShutdown(RTC::UniqueId ec_id)
{
	std::cout << "[onShutdown()]" << std::endl;

  return RTC::RTC_OK;
}


RTC::ReturnCode_t testA::onActivated(RTC::UniqueId ec_id)
{
	dummy = 0.0;
	
	std::cout << "[onActivated()]" << std::endl;

  return RTC::RTC_OK;
}


RTC::ReturnCode_t testA::onDeactivated(RTC::UniqueId ec_id)
{
	std::cout << "[onDeactivated()]" << std::endl;

  return RTC::RTC_OK;
}


RTC::ReturnCode_t testA::onExecute(RTC::UniqueId ec_id)
{
//	std::cout << "[onExecute()]" << std::endl;

	dummy += 0.001;
	m_Send.data = dummy;

	m_SendOut.write();





  return RTC::RTC_OK;
}


RTC::ReturnCode_t testA::onAborting(RTC::UniqueId ec_id)
{
	std::cout << "[onAborting()]" << std::endl;

  return RTC::RTC_OK;
}


RTC::ReturnCode_t testA::onError(RTC::UniqueId ec_id)
{
	std::cout << "[onError()]" << std::endl;

  return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t testA::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t testA::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t testA::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/



extern "C"
{
 
  void testAInit(RTC::Manager* manager)
  {
    coil::Properties profile(testa_spec);
    manager->registerFactory(profile,
                             RTC::Create<testA>,
                             RTC::Delete<testA>);
  }
  
};


