// -*- C++ -*-
/*!
 * @file  testB.cpp
 * @brief testB
 * @date $Date$
 *
 * $Id$
 */

#include "testB.h"

// Module specification
// <rtc-template block="module_spec">
static const char* testb_spec[] =
  {
    "implementation_id", "testB",
    "type_name",         "testB",
    "description",       "testB",
    "version",           "1.0.0",
    "vendor",            "VenderName",
    "category",          "Category",
    "activity_type",     "PERIODIC",
    "kind",              "DataFlowComponent",
    "max_instance",      "1",
    "language",          "C++",
    "lang_type",         "compile",
    "exec_cxt.periodic.rate", "1.0",
    ""
  };
// </rtc-template>

/*!
 * @brief constructor
 * @param manager Maneger Object
 */
testB::testB(RTC::Manager* manager)
    // <rtc-template block="initializer">
  : RTC::DataFlowComponentBase(manager),
    m_ReceiveIn("Receive", m_Receive)

    // </rtc-template>
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  registerInPort("Receive", m_ReceiveIn);
  
  // Set OutPort buffer
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  
  // </rtc-template>

}

/*!
 * @brief destructor
 */
testB::~testB()
{
}



RTC::ReturnCode_t testB::onInitialize()
{
	std::cout << "[onInitialize()]" << std::endl;

  return RTC::RTC_OK;
}


RTC::ReturnCode_t testB::onFinalize()
{
	std::cout << "[onFinalize()]" << std::endl;

  return RTC::RTC_OK;
}


RTC::ReturnCode_t testB::onStartup(RTC::UniqueId ec_id)
{
	std::cout << "[onStartup()]" << std::endl;

  return RTC::RTC_OK;
}



RTC::ReturnCode_t testB::onShutdown(RTC::UniqueId ec_id)
{
	std::cout << "[onShutdown()]" << std::endl;

  return RTC::RTC_OK;
}



RTC::ReturnCode_t testB::onActivated(RTC::UniqueId ec_id)
{
	std::cout << "[onActivated()]" << std::endl;

  return RTC::RTC_OK;
}


RTC::ReturnCode_t testB::onDeactivated(RTC::UniqueId ec_id)
{
	std::cout << "[onDeactivated()]" << std::endl;

  return RTC::RTC_OK;
}


RTC::ReturnCode_t testB::onExecute(RTC::UniqueId ec_id)
{
//	std::cout << "[onExecute()]" << std::endl;


	if (m_ReceiveIn.isNew()) {
		m_ReceiveIn.read();
		std::cout << "sec = " << m_Receive.tm.sec << ", nsec = " << m_Receive.tm.nsec << ", data = " << m_Receive.data << std::endl;
	}

  return RTC::RTC_OK;
}


RTC::ReturnCode_t testB::onAborting(RTC::UniqueId ec_id)
{
	std::cout << "[onAborting()]" << std::endl;

  return RTC::RTC_OK;
}


RTC::ReturnCode_t testB::onError(RTC::UniqueId ec_id)
{
	std::cout << "[onError()]" << std::endl;

  return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t testB::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t testB::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t testB::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/



extern "C"
{
 
  void testBInit(RTC::Manager* manager)
  {
    coil::Properties profile(testb_spec);
    manager->registerFactory(profile,
                             RTC::Create<testB>,
                             RTC::Delete<testB>);
  }
  
};


